Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ3.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ3.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ3.m	(revision 623)
@@ -1,108 +1,83 @@
-XQ3	;LL/THM,SF/GJL,SEA/JLI - CLEANUP DANGLING POINTERS IN OPTION OR HELP FRAME FILES ;04/30/08  17:06
-	;;8.0;KERNEL;**80,501**;Jul 10, 1995;Build 1
-	Q
-ENASK	;Ask to fix up dirty OPTION/HELP FRAME File
-	N IX,XUT,J,K,XQFL,X
-	I '$D(%) W !,$C(7),"ENTRY MUST BE WITH THE VARIABLE '%' SET TO INDICATE DESIRED FILE.",$C(7),! Q
-	S XQFL=$S(%=1:"OPTION",%=2:"PROTOCOL",1:"HELP FRAME")
-	W !,"Do you want to remove any 'Dangling Pointers' from your ",XQFL," File?  Y// " R X:$S($D(DTIME):DTIME,1:300) I '$T Q
-	W ! I X="" S X="Y"
-	I X["?" G SYNTAX
-	I X["^" S X="^" Q
-STRIP	I X'="",X'?1A.E S X=$E(X,2,256) G STRIP
-	S X=$E(X,1) I X="" G SYNTAX
-	I "Nn"[X S X="N" Q
-	I "Yy"[X W !,"PLEASE WAIT while I check this out . . . " G REMOVE
-SYNTAX	W ! I X'["?" W ?11,"I'm sorry, but I don't understand your answer. Please"
-	W !,"Enter: YES (or press the RETURN key) if you want me to remove from"
-	W !,?11,"your ",XQFL," File any pointers left over from incompletely"
-	W !,?11,"deleted ",XQFL,". If such pointers do exist and are not"
-	W !,?11,"removed, the ",XQFL," File (i.e. the menus) could become"
-	W !,?11,"messed up by an INIT."
-	W !!,"Enter:  NO or ^ to continue on without effecting the ",XQFL," File."
-	W ! G ENASK
-REMOVE	D:%=1 OPFIX D:%=2 PFIX D:'% HFFIX W !,"Your ",XQFL," File is OK " I 'XUT W "(no bad pointers)."
-	E  W "now (",XUT," pointer" W:XUT>1 "s" W " fixed)."
-	W ! S X="Y"
-	Q
-OPFIX	;Kill any dangling pointers in the OPTION File (#19)
-	N %,IX,J,XQ3
-	S (IX,XUT)=0 ;XUT=Total Deletions
-	F  S IX=$O(^DIC(19,IX)) Q:'IX  W:'(IX#100) ". " S (XQ3,J)=0 D L2 ;Loop through Options
-	D NPF
-	Q
-L2	;One Option
-	I '$D(^DIC(19,IX,10,0)) Q  ;Not a Menu
-	K ^DIC(19,IX,10,"B") ;Rebuild "B" X-ref
-	F  S J=$O(^DIC(19,IX,10,J)) Q:'J  D ITEM ;Loop through menu items
-	S (K,J)=0 F  S J=$O(^DIC(19,IX,10,J)) Q:J'>0  S K=J ;K=Last item
-	S J=^DIC(19,IX,10,0),^(0)=$P(J,"^",1,2)_"^"_K_"^"_XQ3 ;fix counters
-	Q
-	;
-ITEM	;One Menu item
-	N DA,DIK
-	S K=+^DIC(19,IX,10,J,0)
-	I $D(^DIC(19,K,0)) S XQ3=XQ3+1,^DIC(19,IX,10,"B",K,J)="" Q  ;Y=No. of items
-	W !,"Option ",$P(^DIC(19,IX,0),U,1)," points to missing option ",K
-	;S XUT=XUT+1 K ^DIC(19,IX,10,J) ;Kill invalid menu item
-	S XUT=XUT+1,DIK="^DIC(19,DA(1),10,",DA=J,DA(1)=IX D ^DIK ;Trigger Menu-rebuild
-	Q
-	;
-NPF	;Fix the New Person File Option Pointers
-	N IX,I2,J,P,DIK,DIE,DR,DA,XUT
-	S (XUT,IX)=0
-	F  S IX=$O(^VA(200,IX)) Q:'IX  D
-	. S P=+$G(^VA(200,IX,201))
-	. I P,'$D(^DIC(19,P,0)) D
-	. . W !,"User: ",$P(^VA(200,IX,0),U),", Primary Menu points to missing option ",P
-	. . S XUT=XUT+1,DIE="^VA(200,",DA=IX,DR="201///@" D ^DIE
-	. . Q
-	. S I2=0
-	. F  S I2=$O(^VA(200,IX,203,I2)) Q:'I2  D
-	. . S P=+$G(^VA(200,IX,203,I2,0))
-	. . I P,'$D(^DIC(19,P,0)) D
-	. . . W !,"User: ",$P(^VA(200,IX,0),U),", Secondary Menu points to missing option ",P
-	. . . S XUT=XUT+1,DIK="^VA(200,DA(1),203,",DA=I2,DA(1)=IX D ^DIK
-	. . . Q
-	. . Q
-	. Q
-	I XUT W !,"Menu pointers fixed."
-	Q
-HFFIX	; Fix dangling pointers on help frame file
-	N %
-	S (XUT,IX)=0 F  S IX=$O(^DIC(9.2,IX)) Q:IX'>0  I $D(^(IX,2)) D HF1,HF2,HF3
-	Q
-HF1	S (Y,J)=0 F  S J=$O(^DIC(9.2,IX,2,J)) Q:J'>0  I $D(^(J,0)) S K=$P(^(0),U,2),Y=Y+1 I $L(K),'$D(^DIC(9.2,K)) S Y=Y-1,XUT=XUT+1 K ^DIC(9.2,IX,2,J,0)
-	Q
-HF2	S (K,J)=0 F  S J=$O(^DIC(9.2,IX,2,J)) Q:J'>0  S K=J
-	S J=^DIC(9.2,IX,2,0),^(0)=$P(J,U,1,2)_U_K_U_Y
-	Q
-HF3	S K=":" F  S K=$O(^DIC(9.2,IX,2,K)) Q:K=""  S J=-1 F  S J=$O(^DIC(9.2,IX,2,K,J)) Q:J=""  D HF4
-	Q
-HF4	S JJ=0 F  S JJ=$O(^DIC(9.2,IX,2,K,J,JJ)) Q:JJ'>0  I '$D(^DIC(9.2,IX,2,JJ,0)) K ^DIC(9.2,IX,2,K,J,JJ)
-	Q
-PFIX	;Kill any dangling pointers in the PROTOCOL File (#101)
-	N %
-	S (IX,XUT)=0 ;XUT=Total Deletions
-P1	S IX=$O(^ORD(101,IX)) I IX>0 S (Y,J)=0 G P2 ;Loop through protocols
-	Q
-P2	S J=$O(^ORD(101,IX,10,J)) I J>0 G PITEM ;Loop through items
-	I '$D(^ORD(101,IX,10,0)) G P1
-	S (K,J)=0 F L=1:1 S J=$O(^ORD(101,IX,10,J)) Q:J'>0  S K=J ;K=Last item
-	S J=^ORD(101,IX,10,0),^(0)=$P(J,"^",1,2)_"^"_K_"^"_Y ;fix counters
-	G PXREFS
-PITEM	S K=+^ORD(101,IX,10,J,0) I $D(^ORD(101,K,0)) S Y=Y+1 G P2 ;Y=No. of items
-	W !,"Protocol ",$P(^ORD(101,IX,0),U,1)," points to missing protocol ",K
-	;S XUT=XUT+1 K ^ORD(101,IX,10,J) ;Kill invalid menu item
-	S XUT=XUT+1,DIK="^ORD(101,IX,10,",DA=J,DA(1)=IX D ^DIK ;Delete invalid menu item
-	G P2
-PXREFS	S K=":"
-P3	S K=$O(^ORD(101,IX,10,K)) I K="" G P1 ;Loop through cross references
-	S L=-1
-P4	S L=$O(^ORD(101,IX,10,K,L)) I L="" G P3
-	S J=0
-P5	S J=$O(^ORD(101,IX,10,K,L,J)) I J'>0 G P4
-	I '$D(^ORD(101,IX,10,J,0)) G PKILLXR ;kill xref to invalid item
-P6	S M=^ORD(101,IX,10,J,0) I (M=L)!(M[L_"^") G P5
-PKILLXR	K ^ORD(101,IX,10,K,L,J) I $O(^ORD(101,IX,10,K,L,-1))="" K ^ORD(101,IX,10,K,L)
-	G P5
+XQ3 ;LL/THM,SF/GJL,SEA/JLI - CLEANUP DANGLING POINTERS IN OPTION OR HELP FRAME FILES ;04/21/98  13:20
+ ;;8.0;KERNEL;**80**;Jul 10, 1995
+ Q
+ENASK ;Ask to fix up dirty OPTION/HELP FRAME File
+ I '$D(%) W !,$C(7),"ENTRY MUST BE WITH THE VARIABLE '%' SET TO INDICATE DESIRED FILE.",$C(7),! Q
+ S XQFL=$S(%=1:"OPTION",%=2:"PROTOCOL",1:"HELP FRAME")
+ W !,"Do you want to remove any 'Dangling Pointers' from your ",XQFL," File?  Y// " R X:$S($D(DTIME):DTIME,1:300) I '$T Q
+ W ! I X="" S X="Y"
+ I X["?" G SYNTAX
+ I X["^" S X="^" Q
+STRIP I X'="",X'?1A.E S X=$E(X,2,256) G STRIP
+ S X=$E(X,1) I X="" G SYNTAX
+ I "Nn"[X S X="N" Q
+ I "Yy"[X W !,"PLEASE WAIT while I check this out . . . " G REMOVE
+SYNTAX W ! I X'["?" W ?11,"I'm sorry, but I don't understand your answer. Please"
+ W !,"Enter: YES (or press the RETURN key) if you want me to remove from"
+ W !,?11,"your ",XQFL," File any pointers left over from incompletely"
+ W !,?11,"deleted ",XQFL,". If such pointers do exist and are not"
+ W !,?11,"removed, the ",XQFL," File (i.e. the menus) could become"
+ W !,?11,"messed up by an INIT."
+ W !!,"Enter:  NO or ^ to continue on without effecting the ",XQFL," File."
+ W ! G ENASK
+REMOVE D:%=1 ENFIX D:%=2 PFIX D:'% HFFIX W !,"Your ",XQFL," File is OK " I 'X W "(no bad pointers)."
+ E  W "now (",X," pointer" W:X>1 "s" W " fixed)."
+ W ! S X="Y" Q
+ENFIX ;Kill any dangling pointers in the OPTION File (#19)
+ S (I,X)=0 ;X=Total Deletions
+L1 S I=$O(^DIC(19,I)) I I>0 S (Y,J)=0 G L2 ;Loop through menus
+ Q
+L2 S J=$O(^DIC(19,I,10,J)) I J>0 G ITEM ;Loop through menu items
+ I '$D(^DIC(19,I,10,0)) G L1
+ S (K,J)=0 F L=1:1 S J=$O(^DIC(19,I,10,J)) Q:J'>0  S K=J ;K=Last item
+ S J=^DIC(19,I,10,0),^(0)=$P(J,"^",1,2)_"^"_K_"^"_Y ;fix counters
+ G XREFS
+ITEM S K=+^DIC(19,I,10,J,0) I $D(^DIC(19,K,0)) S Y=Y+1 G L2 ;Y=No. of items
+ W !,"Option ",$P(^DIC(19,I,0),U,1)," points to missing option ",K
+ S X=X+1 K ^DIC(19,I,10,J) ;Kill invalid menu item
+ G L2
+XREFS S K=":"
+L3 S K=$O(^DIC(19,I,10,K)) I K="" G L1 ;Loop through cross references
+ S L=-1
+L4 S L=$O(^DIC(19,I,10,K,L)) I L="" G L3
+ S J=0
+L5 S J=$O(^DIC(19,I,10,K,L,J)) I J'>0 G L4
+ I '$D(^DIC(19,I,10,J,0)) G KILLXR ;kill xref to invalid item
+L6 S M=^DIC(19,I,10,J,0) I (M=L)!(M[L_"^") G L5
+KILLXR K ^DIC(19,I,10,K,L,J) I $O(^DIC(19,I,10,K,L,-1))="" K ^DIC(19,I,10,K,L)
+ G L5
+HFFIX ; Fix dangling pointers on help frame file
+ S (X,I)=0 F  S I=$O(^DIC(9.2,I)) Q:I'>0  I $D(^(I,2)) D HF1,HF2,HF3
+ Q
+HF1 S (Y,J)=0 F  S J=$O(^DIC(9.2,I,2,J)) Q:J'>0  I $D(^(J,0)) S K=$P(^(0),U,2),Y=Y+1 I $L(K),'$D(^DIC(9.2,K)) S Y=Y-1,X=X+1 K ^DIC(9.2,I,2,J,0)
+ Q
+HF2 S (K,J)=0 F  S J=$O(^DIC(9.2,I,2,J)) Q:J'>0  S K=J
+ S J=^DIC(9.2,I,2,0),^(0)=$P(J,U,1,2)_U_K_U_Y
+ Q
+HF3 S K=":" F  S K=$O(^DIC(9.2,I,2,K)) Q:K=""  S J=-1 F  S J=$O(^DIC(9.2,I,2,K,J)) Q:J=""  D HF4
+ Q
+HF4 S JJ=0 F  S JJ=$O(^DIC(9.2,I,2,K,J,JJ)) Q:JJ'>0  I '$D(^DIC(9.2,I,2,JJ,0)) K ^DIC(9.2,I,2,K,J,JJ)
+ Q
+PFIX ;Kill any dangling pointers in the PROTOCOL File (#101)
+ S (I,X)=0 ;X=Total Deletions
+P1 S I=$O(^ORD(101,I)) I I>0 S (Y,J)=0 G P2 ;Loop through protocols
+ Q
+P2 S J=$O(^ORD(101,I,10,J)) I J>0 G PITEM ;Loop through items
+ I '$D(^ORD(101,I,10,0)) G P1
+ S (K,J)=0 F L=1:1 S J=$O(^ORD(101,I,10,J)) Q:J'>0  S K=J ;K=Last item
+ S J=^ORD(101,I,10,0),^(0)=$P(J,"^",1,2)_"^"_K_"^"_Y ;fix counters
+ G PXREFS
+PITEM S K=+^ORD(101,I,10,J,0) I $D(^ORD(101,K,0)) S Y=Y+1 G P2 ;Y=No. of items
+ W !,"Option ",$P(^ORD(101,I,0),U,1)," points to missing option ",K
+ S X=X+1 K ^ORD(101,I,10,J) ;Kill invalid menu item
+ G P2
+PXREFS S K=":"
+P3 S K=$O(^ORD(101,I,10,K)) I K="" G P1 ;Loop through cross references
+ S L=-1
+P4 S L=$O(^ORD(101,I,10,K,L)) I L="" G P3
+ S J=0
+P5 S J=$O(^ORD(101,I,10,K,L,J)) I J'>0 G P4
+ I '$D(^ORD(101,I,10,J,0)) G PKILLXR ;kill xref to invalid item
+P6 S M=^ORD(101,I,10,J,0) I (M=L)!(M[L_"^") G P5
+PKILLXR K ^ORD(101,I,10,K,L,J) I $O(^ORD(101,I,10,K,L,-1))="" K ^ORD(101,I,10,K,L)
+ G P5
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ5.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ5.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ5.m	(revision 623)
@@ -1,102 +1,95 @@
-XQ5	;SF/GFT,MJM,KLD - Menu edit utilities [XUEDITOPT] ;01/30/2008
-	;;8.0;KERNEL;**44,130,484**;Jul 10, 1995;Build 2
-	; Per VHA Directive 2004-038, this routine should not be modified.
-	; Option & Input Template: XUEDITOPT
-DIP	;
-	K DIC S DIC=.4,DIC(0)="AEQMZ" I $D(^DIC(19,DA,63)),^(63)?1"[".E1"]" S DIC("B")=$E(^(63),2,$L(^(63))-1)
-	S DUZ0=$S(DUZ(0)="@"!$D(^XUSEC("XUMGR",DUZ)):1,1:0) G:DUZ0 DIP1 S DIC("S")="I 1 Q:'$D(^DIC(+$P(^(0),U,4),0,""RD""))  F %=1:1:$L(^(""RD"")) I DUZ(0)[$E(^(""RD""),%) Q"
-DIP1	;
-	D:$G(DUZ0) PRNT
-	D ^DIC K DIC G:Y<0&(DUZ(0)'="@") Q G:Y<0&(DUZ0) Q1 S XQDIC=+$P(Y(0),U,4) G:XQDIC'>1 Q S XQ=$P(^DIC(XQDIC,0),U,1)_U_XQDIC,XQ(63)="["_$P(Y,U,2)_"]",XQ(60)=$P(^(0,"GL"),U,2),XQ(62)=0
-BY	;
-	D:$G(DUZ0) SORT
-	K DIC S DIC=.401,DIC(0)="AEQMZ" I $D(^DIC(19,DA,64)),^(64)?1"[".E1"]" S DIC("B")=$E(^(64),2,$L(^(64))-1)
-	S DIC("S")="I $P(^(0),U,4)=XQDIC" G:DUZ0 BY1 S DIC("S")=DIC("S")_" Q:'$D(^DIC(+$P(^(0),U,4),0,""RD""))  F %=1:1:$L(^(""RD"")) I DUZ(0)[$E(^(""RD""),%) Q"
-BY1	;
-	D ^DIC K DIC G TEM:X="",Q:Y<0 S XQDIC=+$P(Y(0),U,4),XQ=$P(^DIC(XQDIC,0),U,1)_U_XQDIC,XQ(64)="["_$P(Y,U,2)_"]" G FR
-TEM	;
-	I +X=X,'$D(^DD(+$P(XQ,U,2),X,0)) W *7,"NO SUCH FIELD NUMBER" K X G BY
-	S XQ(64)=X
-FR	K X S Y=$S($D(^DIC(19,DA,65)):^(65),1:"") W !,"START WITH: ",$S(Y]"":Y,1:"FIRST")_"// " R X:DTIME G:X=U Q S:X="" X=Y W:X="?" !?4,"ENTER IN 'FR' FORMAT" G:X="?" FR K:X="@" X,^DIC(19,DA,65) W:'$D(X) *7,"   DELETED!" S:$D(X) XQ(65)=X
-TO	K X S Y=$S($D(^DIC(19,DA,66)):^(66),1:"") W !,"GO TO: ",$S(Y]"":Y,1:"LAST")_"// " R X:DTIME G:X=U Q S:X="" X=Y W:X="?" !?4,"ENTER IN 'TO' FORMAT" G:X="?" TO K:X="@" X,^DIC(19,DA,66) W:'$D(X) *7,"   DELETED!" S:$D(X) XQ(66)=X
-	D PUT G Q1
-DIE	;
-	S DUZ0=$S(DUZ(0)="@"!$D(^XUSEC("XUMGR",DUZ)):1,1:0)
-	K DIC,XQ S DIC=.402,DIC(0)="AQEMZ" I $D(^DIC(19,DA,51)),^(51)?1"[".E1"]" S DIC("B")=$E(^(51),2,$L(^(51))-1)
-	G:DUZ0 DIE1 S DIC("S")="I 1 Q:'$D(^DIC(+$P(^(0),U,4),0,""WR""))  F %=1:1:$L(^(""WR"")) I DUZ(0)[$E(^(""WR""),%) Q"
-DIE1	;
-	D ^DIC K DIC G:Y<0&(DUZ(0)'="@") Q G:Y<0&(DUZ0) Q1 S XQDIC="",XQDIC=+$P(Y(0),U,4) G:'XQDIC Q S XQ(51)="["_$P(Y,U,2)_"]" D DIC S XQ(50)=XQ(30) D PUT G Q1
-PUT	S X=0 F  S X=$O(XQ(X)) Q:X'>0  S ^DIC(19,DA,X)=XQ(X)
-	Q
-	;
-Q	W *7,!,"NO CHANGE MADE TO OPTION LOGIC"
-Q1	K XQDIC,XQ,Y S DIC=DIE Q
-	;
-DIC	S XQ=$P(^DIC(XQDIC,0),U,1),XQ(30)=$P(^(0,"GL"),U,2)
-	S XQ(31)=$G(^DIC(19,DA,31)) S:XQ(31)="" XQ(31)="AEMQ"
-	I $D(^DIC(XQDIC,0,"LAYGO")),DUZ(0)'="@" S Y=$L(^("LAYGO")) I Y F %=1:1 I DUZ(0)[$E(^("LAYGO"),%) G A:%>Y Q
-	W !,"WHEN USER SELECTS AN ENTRY IN THE '"_XQ_"' FILE,",!,"WILL ADDING A NEW ENTRY AT THAT TIME ('LAYGO') BE ALLOWED"
-	S %=$S(XQ(31)["L":0,1:2) D YN^DICN
-	I %=1 I XQ(31)'["L" S XQ(31)=XQ(31)_"L"
-	I %=2 I XQ(31)["L" S XQ(31)=$TR(XQ(31),"L")
-A	Q
-	;
-DIQ	;
-	S DUZ0=$S(DUZ(0)="@"!$D(^XUSEC("XUMGR",DUZ)):1,1:0)
-	K DIC,XQ S DIC=1,DIC(0)="AEQMZ",DIC("A")="INQUIRE TO WHAT FILE: "
-	I $D(^DIC(19,DA,30)),^(30)["(",@("$D(^"_^(30)_"0))") S DIC("B")=+$P(^(0),U,2)
-	G:DUZ0 DIQ1 S DIC("S")="I 1 Q:'$D(^(0,""RD""))  F %=1:1:$L(^(""RD"")) I DUZ(0)[$E(^(""RD""),%) Q"
-DIQ1	;
-	D ^DIC K DIC G:Y<0 Q  S (XQ(80),XQ(30))=$P(^(0,"GL"),U,2)
-	S XQ(31)=$G(^DIC(19,DA,31)) S:XQ(31)="" XQ(31)="AEMQ"
-	D PUT G Q1
-	;
-NAME	;
-	I $E(X,1)="A"!($E(X,1)="Z") S %=1,%1="Local" Q
-	F %=4:-1:2 G:$D(^DIC(9.4,"C",$E(X,1,%))) NAMEOK
-	I 0
-	Q
-NAMEOK	S %1=$O(^DIC(9.4,"C",$E(X,1,%),0)) S:%1="" %1=-1 S:$D(^DIC(9.4,%1,0)) %1=$P(^(0),U,1),XQPK=%1 I 1 Q
-	;
-CHKNAME	;Called from the input transform of the .01 field of the Option File
-	Q:$D(DIFROM)!($D(ZTQUEUED))  K XQPK
-	I $D(DIC(0))#2,DIC(0)'["E" Q
-	D NAME E  D EN^DDIOL("Not a known package or a local namespace.") Q
-	D EN^DDIOL("  Located in the "_$E(X,1,%)_" ("_%1_") namespace.") Q
-	;
-PRNT	W !,?16,"*** IMPORTANT PLEASE READ ***",!
-	W !,"By selecting a new Print/Sort Template below, your defaults will"
-	W !,"be changed. Your defaults are currently set as follows (see below)."
-	W !,"Should you desire to keep the defaults as they are, or to revise"
-	W !,"one or more, enter an '^' up-arrow, without selecting a new"
-	W !,"template name."
-	W !!,?23,"Default Values",!,?23,"==============",!
-	W !,?5,"DIC {DIP}: "_$$GET1^DIQ(19,DA,60)
-	W ?40,"L.: "_$$GET1^DIQ(19,DA,62)
-	W !,?5,"FLDS: "_$$GET1^DIQ(19,DA,63)
-	W ?40,"BY: "_$$GET1^DIQ(19,DA,64)
-	W !,?5,"FR: "_$$GET1^DIQ(19,DA,65)
-	W ?40,"TO: "_$$GET1^DIQ(19,DA,66),!!
-	Q
-	;
-SORT	W !,?16,"*** IMPORTANT PLEASE READ ***",!
-	W !,"By selecting a new Sort Template below, your defaults will be"
-	W !,"changed. Your defaults are currently set as follows (see below)."
-	W !,"Should you desire to keep the defaults as they are, or to revise"
-	W !,"one or more, enter an '^' up-arrow, without selecting a new Sort"
-	W !,"Template."
-	W !!,?23,"Default Values",!,?23,"==============",!
-	W ?5,"BY: "_$$GET1^DIQ(19,DA,64)
-	W !,?5,"FR: "_$$GET1^DIQ(19,DA,65)
-	W ?40,"TO: "_$$GET1^DIQ(19,DA,66),!!
-	Q
-TEST	W !,"Enter a name, and the computer will respond with the namespace to which",!,"that name belongs.  It does this by looking at the package file.",!!
-T1	R !,"NAME: ",X:DTIME,"  " Q:X=""  D CHKNAME G T1
-CLEAR	;Clear fields not used by this option.
-	I "EMPRSOQ"[X X "F %="_$S("M"[X:"25,27:1:82","QO"[X:"25,31:1:82","RS"[X:"10,30:1:82","E"[X:"10,25,60:1:82","P"[X:"10,25,27:1:54,80:1:82")_" I $D(^DIC(19,DA,%)) D:%=10 CLEAR1 K ^DIC(19,DA,%)"
-	I "AI"[X X "F %="_$S("A"[X:"10,25,30:1:82","I"[X:"10,25,36:1:62,64:1:73")_" I $D(^DIC(19,DA,%)) D:%=10 CLEAR1 K ^DIC(19,DA,%)"
-	I "OQ"'[X F %=100,100.1,100.2 I $D(^DIC(19,DA,%)) K ^DIC(19,DA,%)
-	Q
-CLEAR1	S XQI=0 F  S XQI=$O(^DIC(19,DA,%,XQI)) Q:XQI'>0  S XQJ=$P(^(XQI,0),U) K ^DIC(19,"AD",$E(XQJ,1,30),DA,XQI)
-	K XQI,XQJ
-	Q
+XQ5 ;SF/GFT,MJM,KLD - Menu edit utilities [XUEDITOPT] ;09/20/96  15:33
+ ;;8.0;KERNEL;**44,130**;Jul 10, 1995
+DIP ;
+ K DIC S DIC=.4,DIC(0)="AEQMZ" I $D(^DIC(19,DA,63)),^(63)?1"[".E1"]" S DIC("B")=$E(^(63),2,$L(^(63))-1)
+ S DUZ0=$S(DUZ(0)="@"!$D(^XUSEC("XUMGR",DUZ)):1,1:0) G:DUZ0 DIP1 S DIC("S")="I 1 Q:'$D(^DIC(+$P(^(0),U,4),0,""RD""))  F %=1:1:$L(^(""RD"")) I DUZ(0)[$E(^(""RD""),%) Q"
+DIP1 ;
+ D:$G(DUZ0) PRNT
+ D ^DIC K DIC G:Y<0&(DUZ(0)'="@") Q G:Y<0&(DUZ0) Q1 S XQDIC=+$P(Y(0),U,4) G:XQDIC'>1 Q S XQ=$P(^DIC(XQDIC,0),U,1)_U_XQDIC,XQ(63)="["_$P(Y,U,2)_"]",XQ(60)=$P(^(0,"GL"),U,2),XQ(62)=0
+BY ;
+ D:$G(DUZ0) SORT
+ K DIC S DIC=.401,DIC(0)="AEQMZ" I $D(^DIC(19,DA,64)),^(64)?1"[".E1"]" S DIC("B")=$E(^(64),2,$L(^(64))-1)
+ S DIC("S")="I $P(^(0),U,4)=XQDIC" G:DUZ0 BY1 S DIC("S")=DIC("S")_" Q:'$D(^DIC(+$P(^(0),U,4),0,""RD""))  F %=1:1:$L(^(""RD"")) I DUZ(0)[$E(^(""RD""),%) Q"
+BY1 ;
+ D ^DIC K DIC G TEM:X="",Q:Y<0 S XQDIC=+$P(Y(0),U,4),XQ=$P(^DIC(XQDIC,0),U,1)_U_XQDIC,XQ(64)="["_$P(Y,U,2)_"]" G FR
+TEM ;
+ I +X=X,'$D(^DD(+$P(XQ,U,2),X,0)) W *7,"NO SUCH FIELD NUMBER" K X G BY
+ S XQ(64)=X
+FR K X S Y=$S($D(^DIC(19,DA,65)):^(65),1:"") W !,"START WITH: ",$S(Y]"":Y,1:"FIRST")_"// " R X:DTIME G:X=U Q S:X="" X=Y W:X="?" !?4,"ENTER IN 'FR' FORMAT" G:X="?" FR K:X="@" X,^DIC(19,DA,65) W:'$D(X) *7,"   DELETED!" S:$D(X) XQ(65)=X
+TO K X S Y=$S($D(^DIC(19,DA,66)):^(66),1:"") W !,"GO TO: ",$S(Y]"":Y,1:"LAST")_"// " R X:DTIME G:X=U Q S:X="" X=Y W:X="?" !?4,"ENTER IN 'TO' FORMAT" G:X="?" TO K:X="@" X,^DIC(19,DA,66) W:'$D(X) *7,"   DELETED!" S:$D(X) XQ(66)=X
+ D PUT G Q1
+DIE ;
+ S DUZ0=$S(DUZ(0)="@"!$D(^XUSEC("XUMGR",DUZ)):1,1:0)
+ K DIC,XQ S DIC=.402,DIC(0)="AQEMZ" I $D(^DIC(19,DA,51)),^(51)?1"[".E1"]" S DIC("B")=$E(^(51),2,$L(^(51))-1)
+ G:DUZ0 DIE1 S DIC("S")="I 1 Q:'$D(^DIC(+$P(^(0),U,4),0,""WR""))  F %=1:1:$L(^(""WR"")) I DUZ(0)[$E(^(""WR""),%) Q"
+DIE1 ;
+ D ^DIC K DIC G:Y<0&(DUZ(0)'="@") Q G:Y<0&(DUZ0) Q1 S XQDIC="",XQDIC=+$P(Y(0),U,4) G:'XQDIC Q S XQ(51)="["_$P(Y,U,2)_"]" D DIC S XQ(50)=XQ(30) D PUT G Q1
+PUT S X=0 F  S X=$O(XQ(X)) Q:X'>0  S ^DIC(19,DA,X)=XQ(X)
+ Q
+ ;
+Q W *7,!,"NO CHANGE MADE TO OPTION LOGIC"
+Q1 K XQDIC,XQ,Y S DIC=DIE Q
+ ;
+DIC S XQ=$P(^DIC(XQDIC,0),U,1),XQ(30)=$P(^(0,"GL"),U,2),XQ(31)="AEMQ"
+ I $D(^DIC(XQDIC,0,"LAYGO")),DUZ(0)'="@" S Y=$L(^("LAYGO")) I Y F %=1:1 I DUZ(0)[$E(^("LAYGO"),%) G A:%>Y Q
+ W !,"WHEN USER SELECTS AN ENTRY IN THE '"_XQ_"' FILE,",!,"WILL ADDING A NEW ENTRY AT THAT TIME ('LAYGO') BE ALLOWED"
+ S %=$S($D(^DIC(19,DA,31)):^(31)'["L"+1,1:0) D YN^DICN I %=1 S XQ(31)="AEMQL"
+A Q
+ ;
+DIQ ;
+ S DUZ0=$S(DUZ(0)="@"!$D(^XUSEC("XUMGR",DUZ)):1,1:0)
+ K DIC,XQ S DIC=1,DIC(0)="AEQMZ",DIC("A")="INQUIRE TO WHAT FILE: "
+ I $D(^DIC(19,DA,30)),^(30)["(",@("$D(^"_^(30)_"0))") S DIC("B")=+$P(^(0),U,2)
+ G:DUZ0 DIQ1 S DIC("S")="I 1 Q:'$D(^(0,""RD""))  F %=1:1:$L(^(""RD"")) I DUZ(0)[$E(^(""RD""),%) Q"
+DIQ1 ;
+ D ^DIC K DIC G:Y<0 Q S XQ(31)="AEMQ",(XQ(80),XQ(30))=$P(^(0,"GL"),U,2) D PUT G Q1
+ ;
+NAME ;
+ I $E(X,1)="A"!($E(X,1)="Z") S %=1,%1="Local" Q
+ F %=4:-1:2 G:$D(^DIC(9.4,"C",$E(X,1,%))) NAMEOK
+ I 0
+ Q
+NAMEOK S %1=$O(^DIC(9.4,"C",$E(X,1,%),0)) S:%1="" %1=-1 S:$D(^DIC(9.4,%1,0)) %1=$P(^(0),U,1),XQPK=%1 I 1 Q
+ ;
+CHKNAME ;Called from the input transform of the .01 field of the Option File
+ Q:$D(DIFROM)!($D(ZTQUEUED))  K XQPK
+ I $D(DIC(0))#2,DIC(0)'["E" Q
+ D NAME E  D EN^DDIOL("Not a known package or a local namespace.") Q
+ D EN^DDIOL("  Located in the "_$E(X,1,%)_" ("_%1_") namespace.") Q
+ ;
+PRNT W !,?16,"*** IMPORTANT PLEASE READ ***",!
+ W !,"By selecting a new Print/Sort Template below, your defaults will"
+ W !,"be changed. Your defaults are currently set as follows(see below)."
+ W !,"Should you desire to keep the defaults as they are, or to revise"
+ W !,"one or more, enter an '^' up-arrow, without selecting a new"
+ W !,"template name."
+ W !!,?23,"Default Values",!,?23,"==============",!
+ W !,?17,"DIC {DIP}: "_$$GET1^DIQ(19,DA,60)
+ W ?40,"L.: "_$$GET1^DIQ(19,DA,62)
+ W !,?17,"FLDS: "_$$GET1^DIQ(19,DA,63)
+ W ?40,"BY: "_$$GET1^DIQ(19,DA,64)
+ W !,?17,"FR: "_$$GET1^DIQ(19,DA,65)
+ W ?40,"TO: "_$$GET1^DIQ(19,DA,66),!!
+ Q
+ ;
+SORT W !,?16,"*** IMPORTANT PLEASE READ ***",!
+ W !,"By selecting a new Sort Template below, your defaults will be"
+ W !,"changed. Your defaults are currently set as follow(see below)."
+ W !,"Should you desire to keep the defaults as they are, or to revise"
+ W !,"one or more, enter an '^' up-arrow, without selecting a new Sort"
+ W !,"Template."
+ W !!,?23,"Default Values",!,?23,"==============",!
+ W ?17,"BY: "_$$GET1^DIQ(19,DA,64)
+ W !,?17,"FR: "_$$GET1^DIQ(19,DA,65)
+ W ?40,"TO: "_$$GET1^DIQ(19,DA,66),!!
+ Q
+TEST W !,"Enter a name, and the computer will respond with the namespace to which",!,"that name belongs.  It does this by looking at the package file.",!!
+T1 R !,"NAME: ",X:DTIME,"  " Q:X=""  D CHKNAME G T1
+CLEAR ;Clear fields not used by this option.
+ I "EMPRSOQ"[X X "F %="_$S("M"[X:"25,27:1:82","QO"[X:"25,31:1:82","RS"[X:"10,30:1:82","E"[X:"10,25,60:1:82","P"[X:"10,25,27:1:54,80:1:82")_" I $D(^DIC(19,DA,%)) D:%=10 CLEAR1 K ^DIC(19,DA,%)"
+ I "AI"[X X "F %="_$S("A"[X:"10,25,30:1:82","I"[X:"10,25,36:1:62,64:1:73")_" I $D(^DIC(19,DA,%)) D:%=10 CLEAR1 K ^DIC(19,DA,%)"
+ I "OQ"'[X F %=100,100.1,100.2 I $D(^DIC(19,DA,%)) K ^DIC(19,DA,%)
+ Q
+CLEAR1 S XQI=0 F  S XQI=$O(^DIC(19,DA,%,XQI)) Q:XQI'>0  S XQJ=$P(^(XQI,0),U) K ^DIC(19,"AD",$E(XQJ,1,30),DA,XQI)
+ K XQI,XQJ
+ Q
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ55.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ55.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XQ55.m	(revision 623)
@@ -1,112 +1,90 @@
-XQ55	; SEA/AMF,MJM,JLI - SEARCH FOR USERS ACCESS TO AN OPTION;
-	;;8.0;KERNEL;**140,342,483,508**;Jul 10, 1995;Build 1
-	;;Per VHA Directive 2004-038, this routine should not be modified
-INIT	;
-	S XQDSH="-------------------------------------------------------------------------------"
-	D ^XQDATE S XQDT=%Y
-OPT	W ! S DIC=19,DIC(0)="AEQM" D ^DIC G:Y=-1 OUT S XQOPT=+Y
-MPAT	W !!,"Show menu paths" S %=2 D YN^DICN G:%<0 OUT S XQMP=2-% I '% W !!,"If you answer 'YES', the listing will include the menu path(s) each user has",!,"to access the specified option." G MPAT
-	K ^TMP($J),XQR,XQP
-	S K=^DIC(19,XQOPT,0),XQHDR="Access to '"_$P(K,U,2)_"'  ["_$P(K,U,1)_"]",XQSCD=0,XQCOM=0,XQNOPRNT=0
-LOOP1	S K=XQOPT,(L,X(0))=0,XQD=K K XQR,XQA,XQK,XQRV S XQR(K)="" I '$L($P(^DIC(19,K,0),U,3)) D TREE1
-	G LOOP2
-	Q
-TREE	S X(L)=$O(^DIC(19,"AD",XQD,X(L))) Q:X(L)'>0  S K=X(L) G:$D(XQR(K)) TREE S XQR(K)=""
-TREE1	;
-	S Y(0)=^DIC(19,K,0) G:$L($P(Y(0),U,3)) TREE S:$L($P(Y(0),U,6)) XQK(L)=$P(Y(0),U,6) S XQA(L)=K I $P(Y(0),U,16) S XQRV(L)=^DIC(19,K,3)
-	D SETGLO S L=L+1,X(L)=0,(XQD,XQD(L))=K D TREE
-	Q:L=1  K XQR(XQD(L)) S L=L-1 K XQA(L),XQK(L),XQRV(L) S XQD=XQD(L) G TREE
-	Q
-SETGLO	;
-	S XQK="" F I=L:-1:0 I $D(XQK(I)),$L(XQK(I)) S XQK=XQK_XQK(I)_","
-	S XQRV="" F I=L:-1:0 I $D(XQRV(I)),$L(XQRV(I)) S XQRV=XQRV_XQRV(I)_","
-	S XQA="" F I=L:-1:1 I $D(XQA(I)) S XQA=XQA_XQA(I)_","
-	S XQA=XQA_XQOPT,J=0 S:$D(^TMP($J,K,0)) J=^(0) S J=J+1,^(0)=J,^TMP($J,K,J)=XQK_U_XQA_U_XQRV
-	Q
-LOOP2	;
-	S XQPA(0)=0,XQP=0 F  S XQP=$O(^TMP($J,XQP)) Q:XQP=""  S XQN=^TMP($J,XQP,0) S XQPS="AP" D USERS S XQPS="AD" D USERS
-	D USERS1 I XQNOPRNT G MUS ; 080115 - add in options from the common menu
-	G LOOP3
-USERS	;
-	S XQU=0 F  S XQU=$O(^VA(200,XQPS,XQP,XQU)) Q:XQU'>0  I $D(^VA(200,XQU,.1)),+$$ACTIVE^XUSER(XQU) D EACHU
-	Q
-USERS1	; 080115 code added to handle options on the COMMON (XUCOMMAND) menu
-	N XUCOMMON
-	S XUCOMMON=$O(^DIC(19,"B","XUCOMMAND",0))
-	S XQP=0 F  S XQP=$O(^TMP($J,XQP)) Q:XQP=""  S XQN=^TMP($J,XQP,0) F J=1:1:XQN Q:'$D(^TMP($J,XQP,J))  I $P($P(^TMP($J,XQP,J),U,2),",")=XUCOMMON D
-	. D  Q:'Y
-	. . W !,"***"
-	. . W !,"*** This option is available from the 'SYSTEM COMMAND OPTIONS'  ***"
-	. . W !,"*** (XUCOMMAND) menu available to all active users unless       ***"
-	. . W !,"*** protected by a KEY - DO YOU REALLY WANT THE ENTIRE LIST     ***"
-	. . W !,"*** OF THESE USERS???                                           ***",!
-	. . N DIR S DIR(0)="Y" D ^DIR S:'Y XQNOPRNT=1 Q:'Y
-	. . Q
-	. S XQU=0,XQPS="(C)" F  S XQU=$O(^VA(200,XQU)) Q:XQU'>0  I $D(^VA(200,XQU,.1)),+$$ACTIVE^XUSER(XQU),$$KEYCHECK() S II=1 D SETU
-	Q
-	;
-EACHU	;
-	S II=1
-	F J=1:1:XQN Q:'$D(^TMP($J,XQP,J))  I $$KEYCHECK() D SETU ; 080115
-	Q
-	;
-KEYCHECK()	; 080115 extracted common code
-	; returns 1 if user has access to the option, 0 if the user does not have access
-	S XQK=$P(^TMP($J,XQP,J),U,1),XX=$L(XQK,",")-1,XQGO=1
-	I XX F X=1:1:XX S Y=$P(XQK,",",X) I Y'="",('$D(^XUSEC(Y,XQU))) S XQGO=0
-	S XQK=$P(^TMP($J,XQP,J),U,3),XX=$L(XQK,",")-1
-	I XX F X=1:1:XX S Y=$P(XQK,",",X) I Y'="",($D(^XUSEC(Y,XQU))) S XQGO=0
-	Q XQGO
-	;
-SETU	;
-	S XQPA=$P(^TMP($J,XQP,J),U,2)
-	I '$D(XQPA(XQPA)) S I=XQPA(0)+1,XQPA(0)=I,XQPA(0,I)=XQPA,XQPA(XQPA)=I
-	S XQPA=XQPA(XQPA) S:XQPS="AD" XQPA=XQPA_"(S)",XQSCD=1 S:XQPS="(C)" XQPA=XQPA_"(C)",XQCOM=1 ; 080115
-	S I=$P(^VA(200,XQU,0),U,1)_U_XQU S:$D(^TMP($J,0,I)) II=$O(^TMP($J,0,I,"A"),-1)+1 S ^TMP($J,0,I,II)=XQPA
-	Q
-LOOP3	;
-	I $O(^TMP($J,0,0))="" W !!,"** NO USERS CAN ACCESS THIS OPTION **" G OUT
-	S %ZIS="MFQ" D ^%ZIS G OUT:POP I $D(IO("Q")) K IO("Q") S ZTRTN="DQ^XQ55",ZTDESC="OPTION ACCESS BY USER",ZTSAVE("XQ*")="",ZTSAVE("^TMP($J,")="" D ^%ZTLOAD K ZTSK,ZTRTN,ZTSAVE,ZTDESC G OUT
-	;
-DQ	;Entry point for queued job
-	U IO
-	S:'XQMP XQPA(0)=-4 S XQPG=0,XQUI=0 D NEWPG G:XQUI MUS
-	S XQU=0 F  S XQU=$O(^TMP($J,0,XQU)) Q:XQU=""  D PRTU G:XQUI MUS
-	D:XQMP MENUPAT G MUS
-NEWPG	;
-	S X="" I XQPG,$E(IOST,1)="C" D CON S XQUI=(X="^") Q:XQUI
-	D HDR Q
-CON	;
-	W !!,"Press return to continue or '^' to escape " R X:DTIME S:'$T X=U
-	Q
-HDR	;
-	W @IOF S XQPG=XQPG+1
-	W "Page ",XQPG,?62,XQDT,!! S XQTAB=(76-$L(XQHDR))/2 W ?XQTAB,XQHDR
-	W !!,"USER NAME",?27,"LAST ON",?37,"PRIMARY MENU" W:XQMP ?63,"PATH(S)"
-	W !,$E(XQDSH,1,25),?27,$E(XQDSH,1,8),?37,$E(XQDSH,1,$S(XQMP:24,1:40)) W:XQMP ?63,$E(XQDSH,1,14)
-	Q
-PRTU	;
-	I $Y>(IOSL-XQPA(0)-8) D:XQMP MENUPAT D NEWPG Q:XQUI
-	S J=$P(XQU,U,2),K="" S:$D(^VA(200,J,1.1)) K=$P(^(1.1),"^") S:$L(K) K=$E(K,4,5)_"/"_$E(K,6,7)_"/"_$E(K,2,3) W !,$E($P(XQU,U,1),1,27),?27,K
-	I $D(^VA(200,J,201)) S K=+^(201) I K>0,$D(^DIC(19,K,0)) W ?37,$E($P(^(0),U,1),1,24)
-	I XQMP D
-	.W ?63,""
-	.S JJ=$O(^TMP($J,0,XQU,"A"),-1)
-	.F II=1:1:JJ W $G(^TMP($J,0,XQU,II)) I II'=JJ W ","
-	I 'XQMP D
-	.S II=0 F  S II=$O(^TMP($J,0,XQU,II)) Q:II'>0  D
-	..I ^TMP($J,0,XQU,II)["(S)" W "  (Secondary menu)" S II="A"
-	Q
-MENUPAT	;
-	W !!,$E(XQDSH,1,27),"     MENU PATH(S)     ",$E(XQDSH,1,29),!
-	F I=1:1:XQPA(0) S K=XQPA(0,I) W !,I,".",?4 F N=1:1 Q:'$L($P(K,",",N))  W:N>1 " ... " W $P(^DIC(19,$P(K,",",N),0),U,1)
-	I XQSCD W !,"(S) - secondary menu pathway"
-	I XQCOM W !,"(C) - SYSTEM COMMAND OPTIONS (XUCOMMAND) menu pathway"
-	Q
-MUS	G:X="^" OUT I $G(XQPG),$E(IOST,1)="C" W !!,"Press return when finished viewing " R X:DTIME W @IOF G OUT
-	I $D(ZTSK) K ^%ZTSK(ZTSK)
-OUT	;
-	D ^%ZISC
-KILL	K XQDT,XQGO,XQN,XQP,XQR,XQRV,XQOPT,XQPA,XQUI,XQSCD,XQDSH,XQU,N,K,J,X,XQA,XQD,XQHDR,XQK,XQP,XQPS,XQMP,XQPG,XX
-	K DIC,I,II,JJ,L,POP,Y,XQNOPRNT I $D(ZTQUEUED),$D(ZTSK),ZTSK>0 K ^%ZTSK(ZTSK)
-	Q
+XQ55 ; SEA/AMF,MJM,JLI - SEARCH FOR USERS ACCESS TO AN OPTION [4/12/04 4:36am]
+ ;;8.0;KERNEL;**140,342**;Jul 10, 1995
+INIT ;
+ S XQDSH="-------------------------------------------------------------------------------"
+ D ^XQDATE S XQDT=%Y
+OPT W ! S DIC=19,DIC(0)="AEQM" D ^DIC G:Y=-1 OUT S XQOPT=+Y
+MPAT W !!,"Show menu paths" S %=2 D YN^DICN G:%<0 OUT S XQMP=2-% I '% W !!,"If you answer 'YES', the listing will include the menu path(s) each user has",!,"to access the specified option." G MPAT
+ K ^TMP($J),XQR,XQP
+ S K=^DIC(19,XQOPT,0),XQHDR="Access to '"_$P(K,U,2)_"'  ["_$P(K,U,1)_"]",XQSCD=0
+LOOP1 S K=XQOPT,(L,X(0))=0,XQD=K K XQR,XQA,XQK,XQRV S XQR(K)="" I '$L($P(^DIC(19,K,0),U,3)) D TREE1
+ G LOOP2
+ Q
+TREE S X(L)=$O(^DIC(19,"AD",XQD,X(L))) Q:X(L)'>0  S K=X(L) G:$D(XQR(K)) TREE S XQR(K)=""
+TREE1 ;
+ S Y(0)=^DIC(19,K,0) G:$L($P(Y(0),U,3)) TREE S:$L($P(Y(0),U,6)) XQK(L)=$P(Y(0),U,6) S XQA(L)=K I $P(Y(0),U,16) S XQRV(L)=^DIC(19,K,3)
+ D SETGLO S L=L+1,X(L)=0,(XQD,XQD(L))=K D TREE
+ Q:L=1  K XQR(XQD(L)) S L=L-1 K XQA(L),XQK(L),XQRV(L) S XQD=XQD(L) G TREE
+ Q
+SETGLO ;
+ S XQK="" F I=L:-1:0 I $D(XQK(I)),$L(XQK(I)) S XQK=XQK_XQK(I)_","
+ S XQRV="" F I=L:-1:0 I $D(XQRV(I)),$L(XQRV(I)) S XQRV=XQRV_XQRV(I)_","
+ S XQA="" F I=L:-1:1 I $D(XQA(I)) S XQA=XQA_XQA(I)_","
+ S XQA=XQA_XQOPT,J=0 S:$D(^TMP($J,K,0)) J=^(0) S J=J+1,^(0)=J,^TMP($J,K,J)=XQK_U_XQA_U_XQRV
+ Q
+LOOP2 ;
+ S XQPA(0)=0,XQP=0 F  S XQP=$O(^TMP($J,XQP)) Q:XQP=""  S XQN=^TMP($J,XQP,0) S XQPS="AP" D USERS S XQPS="AD" D USERS
+ G LOOP3
+USERS ;
+ S XQU=0 F  S XQU=$O(^VA(200,XQPS,XQP,XQU)) Q:XQU'>0  I $D(^VA(200,XQU,.1)),+$$ACTIVE^XUSER(XQU) D EACHU
+ Q
+EACHU ;
+ S II=1
+ F J=1:1:XQN Q:'$D(^TMP($J,XQP,J))  D
+ .S XQK=$P(^TMP($J,XQP,J),U,1),XX=$L(XQK,",")-1,XQGO=1
+ .I XX F X=1:1:XX S Y=$P(XQK,",",X) I Y'="",('$D(^XUSEC(Y,XQU))) S XQGO=0
+ .S XQK=$P(^TMP($J,XQP,J),U,3),XX=$L(XQK,",")-1
+ .I XX F X=1:1:XX S Y=$P(XQK,",",X) I Y'="",($D(^XUSEC(Y,XQU))) S XQGO=0
+ .D:XQGO SETU
+ Q
+SETU ;
+ S XQPA=$P(^TMP($J,XQP,J),U,2)
+ I '$D(XQPA(XQPA)) S I=XQPA(0)+1,XQPA(0)=I,XQPA(0,I)=XQPA,XQPA(XQPA)=I
+ S XQPA=XQPA(XQPA) S:XQPS="AD" XQPA=XQPA_"(S)",XQSCD=1
+ S I=$P(^VA(200,XQU,0),U,1)_U_XQU S:$D(^TMP($J,0,I)) II=$O(^TMP($J,0,I,"A"),-1)+1 S ^TMP($J,0,I,II)=XQPA
+ Q
+LOOP3 ;
+ I $O(^TMP($J,0,0))="" W !!,"** NO USERS CAN ACCESS THIS OPTION **" G OUT
+ S %ZIS="MFQ" D ^%ZIS G OUT:POP I $D(IO("Q")) K IO("Q") S ZTRTN="DQ^XQ55",ZTDESC="OPTION ACCESS BY USER",ZTSAVE("XQ*")="",ZTSAVE("^TMP($J,")="" D ^%ZTLOAD K ZTSK,ZTRTN,ZTSAVE,ZTDESC G OUT
+ ;
+DQ ;Entry point for queued job
+ U IO
+ S:'XQMP XQPA(0)=-4 S XQPG=0,XQUI=0 D NEWPG G:XQUI MUS
+ S XQU=0 F  S XQU=$O(^TMP($J,0,XQU)) Q:XQU=""  D PRTU G:XQUI MUS
+ D:XQMP MENUPAT G MUS
+NEWPG ;
+ S X="" I XQPG,$E(IOST,1)="C" D CON S XQUI=(X="^") Q:XQUI
+ D HDR Q
+CON ;
+ W !!,"Press return to continue or '^' to escape " R X:DTIME S:'$T X=U
+ Q
+HDR ;
+ W @IOF S XQPG=XQPG+1
+ W "Page ",XQPG,?62,XQDT,!! S XQTAB=(76-$L(XQHDR))/2 W ?XQTAB,XQHDR
+ W !!,"USER NAME",?27,"LAST ON",?37,"PRIMARY MENU" W:XQMP ?63,"PATH(S)"
+ W !,$E(XQDSH,1,25),?27,$E(XQDSH,1,8),?37,$E(XQDSH,1,$S(XQMP:24,1:40)) W:XQMP ?63,$E(XQDSH,1,14)
+ Q
+PRTU ;
+ I $Y>(IOSL-XQPA(0)-8) D:XQMP MENUPAT D NEWPG Q:XQUI
+ S J=$P(XQU,U,2),K="" S:$D(^VA(200,J,1.1)) K=$P(^(1.1),"^") S:$L(K) K=$E(K,4,5)_"/"_$E(K,6,7)_"/"_$E(K,2,3) W !,$E($P(XQU,U,1),1,27),?27,K
+ I $D(^VA(200,J,201)) S K=+^(201) I K>0,$D(^DIC(19,K,0)) W ?37,$E($P(^(0),U,1),1,24)
+ I XQMP D
+ .W ?63,""
+ .S JJ=$O(^TMP($J,0,XQU,"A"),-1)
+ .F II=1:1:JJ W $G(^TMP($J,0,XQU,II)) I II'=JJ W ","
+ I 'XQMP D
+ .S II=0 F  S II=$O(^TMP($J,0,XQU,II)) Q:II'>0  D
+ ..I ^TMP($J,0,XQU,II)["(S)" W "  (Secondary menu)" S II="A"
+ Q
+MENUPAT ;
+ W !!,$E(XQDSH,1,27),"     MENU PATH(S)     ",$E(XQDSH,1,29),!
+ F I=1:1:XQPA(0) S K=XQPA(0,I) W !,I,".",?4 F N=1:1 Q:'$L($P(K,",",N))  W:N>1 " ... " W $P(^DIC(19,$P(K,",",N),0),U,1)
+ I XQSCD W !,"(S) - secondary menu pathway"
+ Q
+MUS G:X="^" OUT I XQPG,$E(IOST,1)="C" W !!,"Press return when finished viewing " R X:DTIME W @IOF G OUT
+ I $D(ZTSK) K ^%ZTSK(ZTSK)
+OUT ;
+ D ^%ZISC
+KILL K XQDT,XQGO,XQN,XQP,XQR,XQRV,XQOPT,XQPA,XQUI,XQSCD,XQDSH,XQU,N,K,J,X,XQA,XQD,XQHDR,XQK,XQP,XQPS,XQMP,XQPG,XX
+ K DIC,I,II,JJ,L,POP,Y I $D(ZTQUEUED),$D(ZTSK),ZTSK>0 K ^%ZTSK(ZTSK)
+ Q
